#ifndef __KSOPTIONAPISTRUCT_H_INCLUDED__
#define __KSOPTIONAPISTRUCT_H_INCLUDED__
/**
* @file KSOptionApiStruct.h
* @author kevin.shen
* systemKSTradeAPI
* companyKingstar
* history
* 2013/11/18	kevin.shen	 create
*/

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "KSUserApiStructEx.h"
#include "KSOptionApiDataType.h"

namespace KingstarAPI
{
///ִ
struct CThostFtdcInputKSExecOrderActionField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///ִ
	TThostFtdcOrderActionRefType	ExecOrderActionRef;
	///ִ
	TThostFtdcOrderRefType	ExecOrderRef;
	///
	TThostFtdcRequestIDType	RequestID;
	///ǰñ
	TThostFtdcFrontIDType	FrontID;
	///Ự
	TThostFtdcSessionIDType	SessionID;
	///
	TThostFtdcExchangeIDType	ExchangeID;
	///ִ
	TThostFtdcExecOrderSysIDType	ExecOrderSysID;
	///־
	TThostFtdcActionFlagType	ActionFlag;
	///û
	TThostFtdcUserIDType	UserID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
	///־
	TThostFtdcDirectionType	Direction;
	///ִ  -- ӦǷڶԳ
	TThostFtdcStrikeTypeType StrikeType;
	///Ƿͷ
	TThostFtdcIsHoldType IsHold;
};

///ִ
struct CThostFtdcKSExecOrderField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
	///ִ
	TThostFtdcOrderRefType	ExecOrderRef;
	///û
	TThostFtdcUserIDType	UserID;
	///
	TThostFtdcVolumeType	Volume;
	///
	TThostFtdcRequestIDType	RequestID;
	///ҵԪ
	TThostFtdcBusinessUnitType	BusinessUnit;
	///ƽ־
	TThostFtdcOffsetFlagType	OffsetFlag;
	///Ͷױ־
	TThostFtdcHedgeFlagType	HedgeFlag;
	///ִ
	TThostFtdcOrderLocalIDType	ExecOrderLocalID;
	///
	TThostFtdcExchangeIDType	ExchangeID;
	///Ա
	TThostFtdcParticipantIDType	ParticipantID;
	///ͻ
	TThostFtdcClientIDType	ClientID;
	///ԼڽĴ
	TThostFtdcExchangeInstIDType	ExchangeInstID;
	///Ա
	TThostFtdcTraderIDType	TraderID;
	///װ
	TThostFtdcInstallIDType	InstallID;
	///ִύ״̬
	TThostFtdcOrderSubmitStatusType	OrderSubmitStatus;
	///ʾ
	TThostFtdcSequenceNoType	NotifySequence;
	///
	TThostFtdcDateType	TradingDay;
	///
	TThostFtdcSettlementIDType	SettlementID;
	///ִ
	TThostFtdcExecOrderSysIDType	ExecOrderSysID;
	///
	TThostFtdcDateType	InsertDate;
	///ʱ
	TThostFtdcTimeType	InsertTime;
	///ʱ
	TThostFtdcTimeType	CancelTime;
	///ִн
	TThostFtdcExecResultType	ExecResult;
	///Ա
	TThostFtdcParticipantIDType	ClearingPartID;
	///
	TThostFtdcSequenceNoType	SequenceNo;
	///ǰñ
	TThostFtdcFrontIDType	FrontID;
	///Ự
	TThostFtdcSessionIDType	SessionID;
	///û˲ƷϢ
	TThostFtdcProductInfoType	UserProductInfo;
	///״̬Ϣ
	TThostFtdcErrorMsgType	StatusMsg;
	///û
	TThostFtdcUserIDType	ActiveUserID;
	///͹˾
	TThostFtdcSequenceNoType	BrokerExecOrderSeq;
	///
	TKSOptionApplyFlagType OptionApplyFlag;
	///Ʒ
	TThostFtdcInstrumentIDType	ProductID;
	///־
	TThostFtdcDirectionType	Direction;
	///ִ  -- ӦǷڶԳ
	TThostFtdcStrikeTypeType StrikeType;
	///Ƿͷ
	TThostFtdcIsHoldType IsHold;
};

///ִѯ
struct CThostFtdcQryKSExecOrderField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
	///
	TThostFtdcExchangeIDType	ExchangeID;
	///ִ
	TThostFtdcExecOrderSysIDType	ExecOrderSysID;
	///ʼʱ
	TThostFtdcTimeType	InsertTimeStart;
	///ʱ
	TThostFtdcTimeType	InsertTimeEnd;
	///Ͷױ־
	TThostFtdcHedgeFlagType	HedgeFlag;
	///
	TKSOptionApplyFlagType OptionApplyFlag;
	///Ʒ
	TThostFtdcInstrumentIDType	ProductID;
};

///ִ 
struct CThostFtdcInputKSExecOrderField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
	///ִ
	TThostFtdcOrderRefType	ExecOrderRef;
	///û
	TThostFtdcUserIDType	UserID;
	///
	TThostFtdcVolumeType	Volume;
	///
	TThostFtdcRequestIDType	RequestID;
	///ҵԪ
	TThostFtdcBusinessUnitType	BusinessUnit;
	///ƽ־
	TThostFtdcOffsetFlagType	OffsetFlag;
	///Ͷױ־
	TThostFtdcHedgeFlagType	HedgeFlag;
	///־
	TThostFtdcDirectionType	Direction;
	///ִ  -- ӦǷڶԳ
	TThostFtdcStrikeTypeType StrikeType;
	///Ƿͷ
	TThostFtdcIsHoldType IsHold;
	///
	TKSOptionApplyFlagType OptionApplyFlag;
};

///ѯ
struct CKSQryExecOrderVolumeField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
	///Ͷױ־
	TThostFtdcHedgeFlagType	HedgeFlag;
	///
	TKSOptionApplyFlagType OptionApplyFlag;
	///־
	TThostFtdcDirectionType	Direction;
};

///ѯ
struct CKSExecOrderVolumeField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
	///Ͷױ־
	TThostFtdcHedgeFlagType	HedgeFlag;
	///ִ
	TThostFtdcVolumeType	ExecVolume;
	///
	TThostFtdcVolumeType	ActionVolume;
	///ִ
	TThostFtdcVolumeType	ExecedVolume;
	/// 
	TThostFtdcVolumeType	ActionedVolume;
	///־
	TThostFtdcDirectionType	Direction;
};

///ѯֻȨ
struct CKSQrySpotOptionParamsField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///
	TThostFtdcExchangeIDType	ExchangeID;
	///Ʒ
	TThostFtdcInstrumentIDType	ProductID;
	///Ʒ
	TThostFtdcProductClassType	ProductClass;
};

///ѯֻȨ
struct CKSSpotOptionParamsField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///
	TThostFtdcExchangeIDType	ExchangeID;
	///Ʒ
	TThostFtdcInstrumentIDType	ProductID;
	///ȯ
	TThostFtdcPriceType	StockPreClosePrice;
	///Ʒ
	TThostFtdcProductClassType	ProductClass;
};

//ѯȨԼϢ
struct CKSQryOptionInsInfoField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///
	TThostFtdcExchangeIDType	ExchangeID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
};

//ѯȨԼϢ
struct CKSOptionInsInfoField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///
	TThostFtdcExchangeIDType	ExchangeID;
	///Ʒ
	TThostFtdcInstrumentIDType	ProductID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
	///ͱϵ
	TThostFtdcVolumeType RiskFactorNum;
	///ͱϵĸ
	TThostFtdcVolumeType	RiskFactorDen;
	///λ֣ȨԼС֤
	TThostFtdcMoneyType	MinMargin;
};

///ѯȨ
struct CKSQryStockOptionInsCommRateField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
};

///ѯȨԼ
struct CKSStockOptionInsCommRateField
{
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
	///
	TThostFtdcExchangeIDType	ExchangeID;
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///
	TThostFtdcRatioType	OpenRatioByMoney;
	///
	TThostFtdcRatioType	OpenRatioByVolume;
	///ƽ
	TThostFtdcRatioType	CloseRatioByMoney;
	///ƽ
	TThostFtdcRatioType	CloseRatioByVolume;
	///ִ
	TThostFtdcRatioType	StrikeRatioByMoney;
	///ִ
	TThostFtdcRatioType	StrikeRatioByVolume;
};

///ѯȨ֤
struct CKSQryStockOptionInsMarginRateField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
};

///ѯȨ֤
struct CKSStockOptionInsMarginRateField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
	///֤
	TThostFtdcRatioType	MarginRateByMoney;
	///ǰ֤
	TThostFtdcMoneyType	CurrMargin;
};

///KSȨ
struct CThostFtdcKSExecOrderRtnField
{
	///ṹ
	CThostFtdcExecOrderField	 ExecOrder;
	///
	TKSOptionApplyFlagType OptionApplyFlag;
	///Ȩ״̬
	TKSStockOptionNonTradingOrderStatusType	StockOptionOrderStatus;
	///־
	TThostFtdcDirectionType	Direction;
	///ִ  -- ӦǷڶԳ
	TThostFtdcStrikeTypeType StrikeType;
	///Ƿͷ
	TThostFtdcIsHoldType IsHold;
};

///ȨָϢ
struct CKSQryStockOptionAssignmentField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
	///
	TThostFtdcDirectionType	Direction;
};

///ȨָϢ
struct CKSStockOptionAssignmentField
{
	///͹˾
	TThostFtdcBrokerIDType	BrokerID;
	///Ͷߴ
	TThostFtdcInvestorIDType	InvestorID;
	///Լ
	TThostFtdcInstrumentIDType	InstrumentID;
	///
	TThostFtdcDirectionType	Direction;
	///
	TThostFtdcExchangeIDType	ExchangeID;
	///Լ
	TThostFtdcInstrumentNameType	InstrumentName;
	///Ʒ
	TThostFtdcInstrumentIDType	ProductID;
	///Ͷױ־
	TThostFtdcHedgeFlagType	HedgeFlag;
	///ճֲ
	TThostFtdcVolumeType	YdPosition;
	///ȨָɺԼ
	TThostFtdcVolumeType AssInsVo;
	///Ȩ֤ȯ
	TThostFtdcVolumeType AssProVol;
	///ȨָӦ
	TThostFtdcMoneyType  FeePay;
	///ȨC/P־
	TThostFtdcOptionsTypeType OptionsType;
	///Ȩ
	TThostFtdcDateType DeliveryDay;
	///ɺԼʶ
	TThostFtdcInstrumentIDType StockID;
};

}	// end of namespace KingstarAPI
#endif